function [perall,fourtrans]=periodogram_bp(x,dd,npg)
%Ginters Buss 2011
%Wildi periodogram_bp translated from R (use this one for mdfa)
% if useful, cite Ginters Buss, 2014.
% "Tracking economic activity in the euro area: Multivariate
% direct filter approach," OECD Journal: Journal of Business
% Cycle Measurement and Analysis, OECD Publishing,Centre for
% International Research on Economic Tendency Surveys, vol. 2014
% (2), pages 1-20. 	 

    %preparation
    nfit=length(x);
    xx=x(nfit-npg+1:nfit);
    npg2=npg/2;
    perall=zeros(npg2+1,1);
    fourtrans=perall;
    % case without seasonal component
    if dd<3
        for j=1:npg2
            fourtrans(j+1)=exp(1i*[1:2*npg2]*j*pi/npg2)*xx;
            term2=(1-exp(1i*j*pi/npg2))^dd;
            fourtrans(j+1)=fourtrans(j+1)/(1-min(dd,1)+min(dd,1)*term2);
            perall(j+1)=abs(fourtrans(j+1)).^2;
        end
    end
    %case with seasonal component, special treatment for pi/6; there is bug
    %in here - look in Wildi code and correct it
    if dd>=3
        ind=1:npg2;
        ind((npg2/6)*[1:6])=[];
        for j=ind
            fourtrans(j+1)=exp(1i*[1:2*npg2]*j*pi/npg2)*xx;
            term2=abs(1-exp(1i*j*pi/npg2)).^2;
            term3=abs(1-exp(12*1i*j*pi/npg2)).^2; %12 in here
            perall(j+1)=abs(fourtrans(j+1))/(term2*term3);
        end
        perall((npg2/6)*[1:6]+1)=max(perall)*100000;
    end
